//
//  zoomdemoViewController.m
//  zoomdemo
//
//  Created by Michael Heyeck on 3/27/10.
//  Copyright Fair Oaks Labs, Inc. 2010. All rights reserved.
//

#import "Path.h"
#import "PathGroup.h"
#import <QuartzCore/QuartzCore.h>
#import "zoomdemoViewController.h"


@interface zoomdemoViewController ()

@property (nonatomic, retain) UIScrollView* scrollView;

- (void)sizeContent;

@end


@implementation zoomdemoViewController

@synthesize content;

- (UIScrollView*)scrollView
{
	return (UIScrollView*) self.view;
}

- (void)setScrollView:(UIScrollView*)newScrollView
{
	self.view = newScrollView;
}


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    [super viewDidLoad];

	world = CGSizeMake(self.scrollView.frame.size.width*4, self.scrollView.frame.size.height*4);
	scale = 1.0;
	
	[self sizeContent];
	self.scrollView.contentOffset = CGPointMake(1.5*self.scrollView.frame.size.width,
												1.5*self.scrollView.frame.size.height);
	[self.scrollView flashScrollIndicators];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc
{
	// Clear weak delegate reference
	if (self.scrollView.delegate == self)
	{
		self.scrollView.delegate = nil;
	}
	
	[content release];
    [super dealloc];
}

#pragma mark Scroll view delegate methods

- (UIView*)viewForZoomingInScrollView:(UIScrollView*)scrollView
{
	return content;
}

#pragma mark Extension methods

- (void)sizeContent
{
	self.content.frame = CGRectMake(0, 0, world.width*scale, world.height*scale);
	self.scrollView.contentSize = CGSizeMake(CGRectGetMaxX(self.content.frame),
											 CGRectGetMaxY(self.content.frame));
	
	CGSize vpSize = self.scrollView.frame.size;
	CGFloat zoomOutLevels = MAX(ceil(log2(MAX(world.width*scale/vpSize.width, world.height*scale/vpSize.height))), 0);
	CGFloat zoomInLevels = 10;
	
	[(CATiledLayer*)self.content.layer setLevelsOfDetail:zoomOutLevels+zoomInLevels+1];
	[(CATiledLayer*)self.content.layer setLevelsOfDetailBias:zoomInLevels];
	
	self.scrollView.minimumZoomScale = pow(2, -zoomOutLevels);
	self.scrollView.maximumZoomScale = pow(2, zoomInLevels);

	[self.content.layer setNeedsDisplay];
}

@end
